// MediaViewer.cpp: CMediaViewer NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MediaViewer.h"
#include <Dvdmedia.h>
#ifdef VMR9_SUPPORTED
#include <d3d9.h>
#include <Vmr9.h>
#endif
//#include "../Grabber.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// ǉGUID
//////////////////////////////////////////////////////////////////////

// ColorSpace Converter
DEFINE_GUID(CLSID_ColorSpaceConverter,0x1643E180, 0x90F5, 0x11CE, 0x97, 0xD5, 0x00, 0xAA, 0x00, 0x55,0x59,0x5A);

//////////////////////////////////////////////////////////////////////
// }N`
//////////////////////////////////////////////////////////////////////

#define SAFE_RELEASE(pOblect)				if((pOblect)){(pOblect)->Release(); (pOblect) = NULL;}
#define SAFE_RELEASE_EX(pOblect,refCount)	if((pOblect)){refCount=(pOblect)->Release(); (pOblect) = NULL;}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CMediaViewer::CMediaViewer(IEventHandler *pEventHandler)
	: CMediaDecoder(pEventHandler, 1UL, 0UL)
	, m_bInit(false)
	, m_pMediaControl(NULL)

	, m_pFilterGraph(NULL)
	, m_pBonSrcFilter(NULL)
	, m_pAacDecFilter(NULL)
	, m_pMpeg2SeqFilter(NULL)
	, m_pPcmSelFilter(NULL)
	, m_pMp2DemuxFilter(NULL)
	, m_pMpeg2DecFilter(NULL)

	, m_strMpeg2DecorderName()

	, m_pMp2DemuxInterface(NULL)
	, m_pMp2DemuxRefClock(NULL)

	, m_pMp2DemuxVideoMap(NULL)
	, m_pMp2DemuxAudioMap(NULL)

	, m_pVideoWindow(NULL)
	, m_pBasicVideo(NULL)
	, m_pBasicAudio(NULL)
	
	, m_wVideoEsPID(0xFFFFU)
	, m_wAudioEsPID(0xFFFFU)
	
	, m_wVideoWindowX(0)
	, m_wVideoWindowY(0)
	, m_VideoInfo()
	, m_hOwnerWnd(NULL)
	, m_bFullscreen(false)
	, m_dwRegister(0)

	, m_ForceAspectX(0)
	, m_ForceAspectY(0)
	, m_PanAndScan(0)
#ifdef VMR9_SUPPORTED
	, m_bVMR9(false)
	, m_pVMR9(NULL)
	, m_pImageMixer(NULL)
	, m_bGrabber(false)
	, m_pGrabber(NULL)
#endif
{
	// COMCu
	::CoInitialize(NULL);
}

CMediaViewer::~CMediaViewer()
{
	CloseViewer();

	// COMCuJ
	::CoUninitialize();
}

void CMediaViewer::Reset(void)
{
	Stop();

	CMediaDecoder::Reset();

	SetVideoPID(0xFFFFU);
	SetAudioPID(0xFFFFU);

	Play();
}

const bool CMediaViewer::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex > GetInputNum())return false;

	CTsPacket *pTsPacket = dynamic_cast<CTsPacket *>(pMediaData);

	// ̓fBAf[^͌݊Ȃ
	if(!pTsPacket)return false;
	
	// tB^Otɓ
	if(m_pBonSrcFilter){
		return m_pBonSrcFilter->InputMedia(pTsPacket);
		}

	return false;
}

const bool CMediaViewer::OpenViewer(HWND hOwnerHwnd,HWND hMessageDrainHwnd,
									LPCWSTR pszMpeg2Decoder)
{
	if(m_bInit)return false;

	HRESULT hReturn=S_OK;
	ULONG refCount;

	CMediaType MediaTypeVideo;
	CMediaType MediaTypeAudio;	

	IPin *pBonSrcOutputPin = NULL;
	IPin *pMp2DemuxInputPin = NULL;
	IPin *pMp2DemuxVideoPin = NULL;
	IPin *pMp2DemuxAudioPin = NULL;
	IPin *pAacDecInputPin = NULL;
	IPin *pAacDecOutputPin = NULL;
	IPin *pMpeg2SeqInputPin = NULL;
	IPin *pMpeg2SeqOutputPin = NULL;
	IPin *pPcmSelInputPin = NULL;
	IPin *pPcmSelOutputPin = NULL;
	IPin *pMpeg2InPin = NULL;
	IPin *pMpeg2OutPin = NULL;

	try{
		CDirectShowUtil cDSUtil;

		// tB^Ot}l[W\z
		if(::CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, reinterpret_cast<LPVOID *>(&m_pFilterGraph)) != S_OK)throw 1UL;
		AddToRot(m_pFilterGraph, &m_dwRegister);

		// IMediaControlC^tF[X̃NG[
		if(m_pFilterGraph->QueryInterface(IID_IMediaControl, reinterpret_cast<LPVOID *>(&m_pMediaControl)) != S_OK)throw 1UL;

#ifdef VMR9_SUPPORTED
		if (m_bVMR9) {
			if (SUCCEEDED(::CoCreateInstance(CLSID_VideoMixingRenderer9,NULL,
									CLSCTX_INPROC_SERVER,IID_IBaseFilter,
									reinterpret_cast<LPVOID*>(&m_pVMR9)))) {
				if (SUCCEEDED(m_pFilterGraph->AddFilter(m_pVMR9,L"VMR9"))) {
					IVMRFilterConfig *pFilterConfig;
					IVMRWindowlessControl9 *pWindowlessControl;
					IVMRMixerControl9 *pMixerControl;
					RECT rc;

					m_pVMR9->QueryInterface(IID_IVMRFilterConfig9,
									reinterpret_cast<LPVOID*>(&pFilterConfig));
					pFilterConfig->SetRenderingMode(VMRMode_Windowless);
					pFilterConfig->Release();
					m_pVMR9->QueryInterface(IID_IVMRWindowlessControl9,
							reinterpret_cast<LPVOID*>(&pWindowlessControl));
					pWindowlessControl->SetVideoClippingWindow(hOwnerHwnd);
					pWindowlessControl->SetBorderColor(RGB(0,0,0));
					pWindowlessControl->SetAspectRatioMode(VMR9ARMode_None);
					::GetClientRect(hOwnerHwnd,&rc);
					pWindowlessControl->SetVideoPosition(NULL,&rc);
					pWindowlessControl->Release();
					if (SUCCEEDED(m_pVMR9->QueryInterface(IID_IVMRMixerControl9,
							reinterpret_cast<LPVOID*>(&pMixerControl)))) {
						DWORD MixingPref;
						pMixerControl->GetMixingPrefs(&MixingPref);
						MixingPref=(MixingPref&~MixerPref9_DecimateMask)|MixerPref9_NonSquareMixing;
						pMixerControl->SetMixingPrefs(MixingPref);
						pMixerControl->Release();
					}
				} else {
					m_pVMR9->Release();
					m_pVMR9=NULL;
				}
			}
		}
#endif	// VMR9_SUPPORTED

		/* CBonSrcFilter */
		{
			// CX^X쐬
			m_pBonSrcFilter = static_cast<CBonSrcFilter *>(CBonSrcFilter::CreateInstance(NULL, &hReturn));
			if((!m_pBonSrcFilter) || (hReturn != S_OK))throw 1UL;
			m_pBonSrcFilter->AddRef();
			
			// tB^Otɒǉ
			if(m_pFilterGraph->AddFilter(static_cast<IBaseFilter *>(m_pBonSrcFilter), L"BonSrcFilter") != S_OK)throw 1UL;

			// o̓s擾
			if(!(pBonSrcOutputPin = m_pBonSrcFilter->GetPin(0)))throw 1UL;
		}		

		/* MPEG-2 Demultiplexer */
		{
			// MPEG-2 DemultiplexerCX^X쐬
			if(::CoCreateInstance(CLSID_MPEG2Demultiplexer, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, reinterpret_cast<LPVOID *>(&m_pMp2DemuxFilter)) != S_OK)throw 1UL;

			// IMpeg2DemultiplexerC^tF[X̃NG[
			if(m_pMp2DemuxFilter->QueryInterface(IID_IMpeg2Demultiplexer, reinterpret_cast<LPVOID *>(&m_pMp2DemuxInterface)) != S_OK)throw 1UL;

			// MPEG-2 DemultiplexertB^Otɒǉ
			if(m_pFilterGraph->AddFilter(m_pMp2DemuxFilter, L"Mpeg2Demuxer") != S_OK)throw 1UL;

			// MPEG-2 Demultiplexer̓̓s擾
			if(m_pMp2DemuxFilter->FindPin(L"MPEG-2 Stream", &pMp2DemuxInputPin) != S_OK)throw 1UL;
			
			// sڑ(CBonSrcFilter [TS]  [MPEG-2 Stream] MPEG-2 Demultiplexer)
			if(m_pFilterGraph->ConnectDirect(pBonSrcOutputPin, pMp2DemuxInputPin, NULL) != S_OK)throw 1UL;			
			
			// IReferenceClockC^tF[X̃NG[
			if(m_pMp2DemuxFilter->QueryInterface(IID_IReferenceClock, reinterpret_cast<LPVOID *>(&m_pMp2DemuxRefClock)) != S_OK)throw 1UL;

			// t@XNbNI
			if(m_pMp2DemuxFilter->SetSyncSource(m_pMp2DemuxRefClock) != S_OK)throw 1UL;			
			
			// ffBAtH[}bgݒ		
			MediaTypeVideo.InitMediaType();
			MediaTypeVideo.SetType(&MEDIATYPE_Video);
			MediaTypeVideo.SetSubtype(&MEDIASUBTYPE_MPEG2_VIDEO);
			MediaTypeVideo.SetVariableSize();
			MediaTypeVideo.SetTemporalCompression(TRUE);
			MediaTypeVideo.SetSampleSize(0);
			MediaTypeVideo.SetFormatType(&FORMAT_MPEG2Video);
			
			 // tH[}bg\̊m
			MPEG2VIDEOINFO *pVideoInfo = reinterpret_cast<MPEG2VIDEOINFO *>(MediaTypeVideo.AllocFormatBuffer(sizeof(MPEG2VIDEOINFO)));
			if(!pVideoInfo)return false;
			::ZeroMemory(pVideoInfo, sizeof(MPEG2VIDEOINFO));

			// rfIwb_ݒ
			VIDEOINFOHEADER2 &VideoHeader = pVideoInfo->hdr;
			::SetRect(&VideoHeader.rcSource, 0, 0, 720, 480);
			VideoHeader.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
			VideoHeader.bmiHeader.biHeight = 480;
			VideoHeader.bmiHeader.biWidth = 720;

			// fo̓s쐬
			if(m_pMp2DemuxInterface->CreateOutputPin(&MediaTypeVideo, L"Video", &pMp2DemuxVideoPin) != S_OK)throw 1UL;
#ifdef VMR9_SUPPORTED
			m_pMpeg2DemuxVideoPin=pMp2DemuxVideoPin;
#endif

			// fBAtH[}bgݒ	
			MediaTypeAudio.InitMediaType();
			MediaTypeAudio.SetType(&MEDIATYPE_Audio);
			MediaTypeAudio.SetSubtype(&MEDIASUBTYPE_NULL);
			MediaTypeAudio.SetVariableSize();
			MediaTypeAudio.SetTemporalCompression(TRUE);
			MediaTypeAudio.SetSampleSize(0);
			MediaTypeAudio.SetFormatType(&FORMAT_None);

			// o̓s쐬
			if(m_pMp2DemuxInterface->CreateOutputPin(&MediaTypeAudio, L"Audio", &pMp2DemuxAudioPin) != S_OK)throw 1UL;			
			
			// fo̓sIMPEG2PIDMapC^tF[X̃NG[
			if(pMp2DemuxVideoPin->QueryInterface(IID_IMPEG2PIDMap, reinterpret_cast<LPVOID *>(&m_pMp2DemuxVideoMap)) != S_OK)throw 1UL;

			// o̓sIMPEG2PIDMapC^tF[X̃NG[
			if(pMp2DemuxAudioPin->QueryInterface(IID_IMPEG2PIDMap, reinterpret_cast<LPVOID *>(&m_pMp2DemuxAudioMap)) != S_OK)throw 1UL;			
		}

		/* CMpeg2SequenceFilter */
		{
			// CX^X쐬
			m_pMpeg2SeqFilter = static_cast<CMpeg2SequenceFilter *>(CMpeg2SequenceFilter::CreateInstance(NULL, &hReturn));
			if((!m_pMpeg2SeqFilter) || (hReturn != S_OK))throw 1UL;
			m_pMpeg2SeqFilter->AddRef();
			m_pMpeg2SeqFilter->SetRecvCallback(OnMpeg2VideoInfo,this);
			
			// CMpeg2SequenceFiltertB^Otɒǉ
			if(m_pFilterGraph->AddFilter(static_cast<IBaseFilter *>(m_pMpeg2SeqFilter), L"Mpeg2SequenceFilter") != S_OK)throw 1UL;

			// CMpeg2SequenceFilter̓̓s擾
			if(!(pMpeg2SeqInputPin = m_pMpeg2SeqFilter->GetPin(0)))throw 1UL;

			// CMpeg2SequenceFilteȑo̓s擾
			if(!(pMpeg2SeqOutputPin = m_pMpeg2SeqFilter->GetPin(1)))throw 1UL;

			// sڑ(MPEG-2 Demultiplexer [Video]  [] CMpeg2SequenceFilter)
			if(m_pFilterGraph->ConnectDirect(pMp2DemuxVideoPin, pMpeg2SeqInputPin, NULL) != S_OK)throw 1UL;
		}

		/* CAacDecFilter */
		{
			// CAacDecFilterCX^X쐬
			m_pAacDecFilter = static_cast<CAacDecFilter *>(CAacDecFilter::CreateInstance(NULL, &hReturn));
			if((!m_pAacDecFilter) || (hReturn != S_OK))throw 1UL;
			m_pAacDecFilter->AddRef();		
			
			// CAacDecFiltertB^Otɒǉ
			if(m_pFilterGraph->AddFilter(static_cast<IBaseFilter *>(m_pAacDecFilter), L"AacDecFilter") != S_OK)throw 1UL;

			// CAacDecFilter̓̓s擾
			if(!(pAacDecInputPin = m_pAacDecFilter->GetPin(0)))throw 1UL;

			// CAacDecFilteȑo̓s擾
			if(!(pAacDecOutputPin = m_pAacDecFilter->GetPin(1)))throw 1UL;

			// sڑ(MPEG-2 Demultiplexer [Audio]  [] CAacDecFilter)
			if(m_pFilterGraph->ConnectDirect(pMp2DemuxAudioPin, pAacDecInputPin, NULL) != S_OK)throw 1UL;
		}

		/* CPcmSelectFilter */
		{
			// CX^X쐬
			m_pPcmSelFilter = static_cast<CPcmSelectFilter *>(CPcmSelectFilter::CreateInstance(NULL, &hReturn));
			if((!m_pPcmSelFilter) || (hReturn != S_OK))throw 1UL;
			m_pPcmSelFilter->AddRef();

			// CPcmSelectFiltertB^Otɒǉ
			if(m_pFilterGraph->AddFilter(static_cast<IBaseFilter *>(m_pPcmSelFilter), L"PcmSelFilter") != S_OK)throw 1UL;

			// CPcmSelectFilter̓̓s擾
			if(!(pPcmSelInputPin = m_pPcmSelFilter->GetPin(0)))throw 1UL;

			// CPcmSelectFilteȑo̓s擾
			if(!(pPcmSelOutputPin = m_pPcmSelFilter->GetPin(1)))throw 1UL;

			// sڑ(CAacDecFilter  [] CPcmSelectFilter)
			if(m_pFilterGraph->ConnectDirect(pAacDecOutputPin, pPcmSelInputPin, NULL) != S_OK)throw 1UL;
		}		

		/* Mpeg2fR[_[ */
		{

			// 
			if(!cDSUtil.FindFilter(&MEDIATYPE_Video,&MEDIASUBTYPE_MPEG2_VIDEO)) throw 1UL;
			CString strMpeg2Vid;
			CLSID idMpeg2Vid;
			int iIndex;			

			bool bConnectSuccess=false;
			for(iIndex=0;!bConnectSuccess&&iIndex<cDSUtil.GetFilterCount();iIndex++){
				if(cDSUtil.GetFilterInfo(iIndex,&idMpeg2Vid,&strMpeg2Vid)){
					if (pszMpeg2Decoder!=NULL && pszMpeg2Decoder[0]!='\0'
							&& strMpeg2Vid.CompareNoCase(pszMpeg2Decoder)!=0)
						continue;
					if(::CoCreateInstance(idMpeg2Vid, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, reinterpret_cast<LPVOID *>(&m_pMpeg2DecFilter)) == S_OK){				
						// CPcmSelectFiltertB^Otɒǉ
						if(m_pFilterGraph->AddFilter(static_cast<IBaseFilter *>(m_pMpeg2DecFilter), strMpeg2Vid) == S_OK){
							// Mpeg2fR[_[s
							MediaTypeVideo.SetSubtype(&MEDIASUBTYPE_NULL);
							pMpeg2InPin = cDSUtil.GetFilterPin(m_pMpeg2DecFilter,PINDIR_INPUT,NULL);
							pMpeg2OutPin = cDSUtil.GetFilterPin(m_pMpeg2DecFilter,PINDIR_OUTPUT,NULL);

							// sڑ(CMpeg2SequenceFilter  [] Mpeg2Decorder)
							if(m_pFilterGraph->ConnectDirect(pMpeg2SeqOutputPin, pMpeg2InPin, NULL) == S_OK){
								// sڑ
								bConnectSuccess = true;
								} else {
								// sڑŝ߁AtB^Ot菜
								m_pFilterGraph->RemoveFilter(m_pMpeg2DecFilter);
								SAFE_RELEASE(pMpeg2InPin);
								SAFE_RELEASE(pMpeg2OutPin);
								SAFE_RELEASE(m_pMpeg2DecFilter);
								}
							} else {
							// tB^Otɒǉs
							SAFE_RELEASE(m_pMpeg2DecFilter);
							}
						} else {
						// fR[_[̃CX^X쐬s
						}
					} else {
					// tB^擾s
					}
				}
			// ǂꂩ̃tB^Őڑł
			if(bConnectSuccess){
					m_strMpeg2DecorderName = strMpeg2Vid;
				} else {
					m_strMpeg2DecorderName = L"";
					throw 1UL;
				}
		}

		IPin *pVideoOutPin=pMpeg2OutPin;
#if 0	// OoeXg܂܂Ȃ̂ŕۗ
		if (m_bGrabber) {
			m_pGrabber=new CGrabber();
			IBaseFilter *pGrabberFilter;
			bool fSuccess=false;

			m_pGrabber->Init();
			pGrabberFilter=m_pGrabber->GetGrabberFilter();
			if (SUCCEEDED(m_pFilterGraph->AddFilter(pGrabberFilter,
																L"Grabber"))) {
				IPin *pGrabberInPin;

				pGrabberInPin=
						cDSUtil.GetFilterPin(pGrabberFilter,PINDIR_INPUT,NULL);
				if (SUCCEEDED(m_pFilterGraph->Connect(pMpeg2OutPin,
															pGrabberInPin))) {
					fSuccess=true;
					pVideoOutPin=
						cDSUtil.GetFilterPin(pGrabberFilter,PINDIR_OUTPUT,NULL);
				}
			}
			if (!fSuccess) {
				delete m_pGrabber;
				m_pGrabber=NULL;
			}
		}
#endif

#ifdef VMR9_SUPPORTED
		if (m_pVMR9) {
			IFilterGraph2 *pFilterGraph2;

			if (FAILED(m_pFilterGraph->QueryInterface(IID_IFilterGraph2,
								reinterpret_cast<LPVOID*>(&pFilterGraph2)))) {
				pFilterGraph2->Release();
				throw 1UL;
			}
			if (FAILED(pFilterGraph2->RenderEx(pVideoOutPin,
								AM_RENDEREX_RENDERTOEXISTINGRENDERERS,NULL))) {
				pFilterGraph2->Release();
				throw 1UL;
			}
			pFilterGraph2->Release();
		} else
#endif

		// f_[\z
		if(m_pFilterGraph->Render(pVideoOutPin) != S_OK)throw 1UL;

		// _[\z
		if(m_pFilterGraph->Render(pPcmSelOutputPin) != S_OK)throw 1UL;		

#ifdef VMR9_SUPPORTED
		if (m_pVMR9==NULL) {
#endif
		// IVideoWindowC^tF[X̃NG[
		if(m_pFilterGraph->QueryInterface(IID_IVideoWindow, reinterpret_cast<LPVOID *>(&m_pVideoWindow)) != S_OK)throw 1UL;		

		// IBasicVideo2C^[tF[X̃NG[
		if(m_pFilterGraph->QueryInterface(IID_IBasicVideo2, reinterpret_cast<LPVOID *>(&m_pBasicVideo)) != S_OK)throw 1UL;
#ifdef VMR9_SUPPORTED
		}
#endif

		// IBasicAudioC^[tF[X̃NG[
		if(m_pFilterGraph->QueryInterface(IID_IBasicAudio, reinterpret_cast<LPVOID *>(&m_pBasicAudio)) != S_OK)throw 1UL;
		
		// I[iEBhEݒ
		m_hOwnerWnd = hOwnerHwnd;
		if(m_pVideoWindow&&hOwnerHwnd){
			RECT Rect;

			::GetClientRect(hOwnerHwnd, &Rect);
			if (m_pVMR9==NULL) {
				m_pVideoWindow->put_Owner((OAHWND)hOwnerHwnd);
				m_pVideoWindow->put_MessageDrain((OAHWND)hMessageDrainHwnd);
				m_pVideoWindow->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS);
				m_pVideoWindow->put_BackgroundPalette(OATRUE);
				m_pVideoWindow->put_BorderColor(RGB(0,0,0));
				m_pVideoWindow->put_Caption(L"");
				m_pVideoWindow->SetWindowPosition(0, 0, Rect.right - Rect.left, Rect.bottom - Rect.top);
				m_pVideoWindow->SetWindowForeground(OATRUE);
				m_pVideoWindow->put_Visible(OATRUE);
			}
			SetViewSize(Rect.right - Rect.left, Rect.bottom - Rect.top);
		}
		m_bInit=true;
	}
	catch(DWORD dwErrorCode){
		CloseViewer();
		TRACE(TEXT("tB^Ot\zs[dwErrorCode = %lu]\n"), dwErrorCode);
		return false;
		}

	// OtŎQƂāAQƃJEgオĂ̂ŉĂȂ	
	SAFE_RELEASE(pBonSrcOutputPin);
	SAFE_RELEASE(pMp2DemuxVideoPin);
	SAFE_RELEASE(pMp2DemuxAudioPin);
	SAFE_RELEASE(pMp2DemuxInputPin);
	SAFE_RELEASE(pAacDecInputPin);
	SAFE_RELEASE(pAacDecOutputPin);
	SAFE_RELEASE(pMpeg2SeqInputPin);
	SAFE_RELEASE(pMpeg2SeqOutputPin);
	SAFE_RELEASE(pPcmSelInputPin);
	SAFE_RELEASE(pPcmSelOutputPin);
	SAFE_RELEASE(pMpeg2InPin);
	SAFE_RELEASE(pMpeg2OutPin);

	TRACE(TEXT("tB^Ot\z\n"));
	
	return true;
}

void CMediaViewer::CloseViewer(void)
{	
	// COMCX^XJ
	ULONG RefCount=0;
	Stop();
	if(m_pVideoWindow){
		m_pVideoWindow->put_Visible(OAFALSE);
		m_pVideoWindow->put_Owner(NULL);
	}

	SAFE_RELEASE(m_pMp2DemuxVideoMap);
	SAFE_RELEASE(m_pMp2DemuxAudioMap);

	SAFE_RELEASE(m_pMp2DemuxRefClock);
	SAFE_RELEASE(m_pMp2DemuxInterface);
	SAFE_RELEASE(m_pMp2DemuxFilter);
	SAFE_RELEASE(m_pMpeg2DecFilter);

	SAFE_RELEASE_EX(m_pAacDecFilter,RefCount);
	SAFE_RELEASE(m_pBonSrcFilter);
	SAFE_RELEASE(m_pMpeg2SeqFilter);
	SAFE_RELEASE(m_pPcmSelFilter);

#if 0
	if (m_pGrabber!=NULL) {
		delete m_pGrabber;
		m_pGrabber=NULL;
	}
#endif
#ifdef VMR9_SUPPORTED
	SAFE_RELEASE(m_pVMR9);
	if (m_pImageMixer!=NULL) {
		delete m_pImageMixer;
		m_pImageMixer=NULL;
	}
#endif

	SAFE_RELEASE(m_pMediaControl);
	SAFE_RELEASE(m_pVideoWindow);
	
	if(m_dwRegister!=0){
		RemoveFromRot(m_dwRegister);
	}
	m_dwRegister = 0;

	SAFE_RELEASE(m_pFilterGraph);
	// RefCount = 0 ɂȂĂȂ΂ǂŉRꂪ	
}

const bool CMediaViewer::Play(void)
{
	if(!m_pMediaControl)return false;

	// tB^OtĐ
	m_pMediaControl->Pause();
		
	return (m_pMediaControl->Run() == S_OK)? true : false;
}

const bool CMediaViewer::Stop(void)
{
	if(!m_pMediaControl)return false;

	// tB^Ot~
	return (m_pMediaControl->Stop() == S_OK)? true : false;
}

const bool CMediaViewer::SetVideoPID(const WORD wPID)
{
	// fo̓sPID}bsO
	if(!m_pMp2DemuxVideoMap)return false;

	if(wPID == m_wVideoEsPID)return true;

	DWORD dwTempPID;

	// ݂PIDA}bv
	if(m_wVideoEsPID != 0xFFFFU){
		dwTempPID = (DWORD)m_wVideoEsPID;
		if(m_pMp2DemuxVideoMap->UnmapPID(1UL, &dwTempPID) != S_OK)return false;
		}

	// VKPID}bv
	if(wPID != 0xFFFFU){
		dwTempPID = wPID;
		if(m_pMp2DemuxVideoMap->MapPID(1UL, &dwTempPID, MEDIA_ELEMENTARY_STREAM) != S_OK)return false;
		}

	m_wVideoEsPID = wPID;
	
	return true;
}

const bool CMediaViewer::SetAudioPID(const WORD wPID)
{
	// o̓sPID}bsO
	if(!m_pMp2DemuxAudioMap)return false;

	if(wPID == m_wAudioEsPID)return true;

	DWORD dwTempPID;

	// ݂PIDA}bv
	if(m_wAudioEsPID != 0xFFFFU){
		dwTempPID = (DWORD)m_wAudioEsPID;
		if(m_pMp2DemuxAudioMap->UnmapPID(1UL, &dwTempPID) != S_OK)return false;
		}

	// VKPID}bv
	if(wPID != 0xFFFFU){
		dwTempPID = wPID;
		if(m_pMp2DemuxAudioMap->MapPID(1UL, &dwTempPID, MEDIA_ELEMENTARY_STREAM) != S_OK)return false;
		}

	m_wAudioEsPID = wPID;
	
	return true;
}

void CMediaViewer::OnMpeg2VideoInfo(const Mpeg2VideoInfo *pVideoInfo,const LPVOID pParam)
{
	// rfI̍XV
	CMediaViewer *pThis=static_cast<CMediaViewer*>(pParam);
	if(memcmp(&pThis->m_VideoInfo,pVideoInfo,sizeof(Mpeg2VideoInfo))){
		// rfI̍XV
		pThis->m_VideoInfo = *pVideoInfo;
		pThis->ResizeVideoWindow();
		}
}

const bool CMediaViewer::ResizeVideoWindow()
{
	// EBhETCYύX
	if((m_pVideoWindow && m_pBasicVideo)
#ifdef VMR9_SUPPORTED
			|| m_pVMR9
#endif
			){
		WORD wX,wY;

		if(m_bFullscreen){			
			wX = (WORD)GetSystemMetrics(SM_CXSCREEN);
			wY = (WORD)GetSystemMetrics(SM_CYSCREEN);
			} else {
			wX = m_wVideoWindowX;
			wY = m_wVideoWindowY;
			}
		int AspectX,AspectY;
		long vx , vy;
		if((m_ForceAspectX>0 && m_ForceAspectY>0)
			|| (m_VideoInfo.byAspectRatioX>0 && m_VideoInfo.byAspectRatioY>0)){
			double aspect_rate;
			double window_rate = (double)wX / (double)wY;

			if (m_ForceAspectX>0 && m_ForceAspectY>0) {
				AspectX = m_ForceAspectX;
				AspectY = m_ForceAspectY;
			} else {
				AspectX = m_VideoInfo.byAspectRatioX;
				AspectY = m_VideoInfo.byAspectRatioY;
			}
			aspect_rate = (double)AspectX / (double)AspectY;
			if(aspect_rate>window_rate){
				vx = wX;
				vy = vx * AspectY  / AspectX;
			} else {
				vy = wY;
				vx = vy * AspectX / AspectY;
			}
		} else {
			vx = wX;
			vy = wY;
			AspectX=vx;
			AspectY=vy;
		}
		HRESULT hr;
		long SrcX,SrcY,SrcWidth,SrcHeight;

		CalcSourcePosition(&SrcX,&SrcY,&SrcWidth,&SrcHeight);
#ifdef VMR9_SUPPORTED
		if (m_pVMR9) {

			IVMRWindowlessControl9 *pWindowlessControl;
			RECT rcSrc,rcDst;

			if (SUCCEEDED(m_pVMR9->QueryInterface(IID_IVMRWindowlessControl9,
							reinterpret_cast<LPVOID*>(&pWindowlessControl)))) {
				LONG Width,Height;

				if (SUCCEEDED(pWindowlessControl->GetNativeVideoSize(
												&Width,&Height,NULL,NULL))) {
					WORD VideoWidth,VideoHeight;

					GetVideoSize(&VideoWidth,&VideoHeight);
					rcSrc.left=SrcX*Width/VideoWidth;
					rcSrc.top=SrcY*Height/VideoHeight;
					rcSrc.right=(SrcX+SrcWidth)*Width/VideoWidth;
					rcSrc.bottom=(SrcY+SrcHeight)*Height/VideoHeight;
				} else {
					rcSrc.left=SrcX;
					rcSrc.top=SrcY;
					rcSrc.right=SrcX+SrcWidth;
					rcSrc.bottom=SrcY+SrcHeight;
				}
				rcDst.left=(wX-vx)/2;
				rcDst.top=(wY-vy)/2,
				rcDst.right=rcDst.left+vx;
				rcDst.bottom=rcDst.top+vy;
				pWindowlessControl->SetVideoPosition(&rcSrc,&rcDst);
				pWindowlessControl->Release();
				InvalidateRect(m_hOwnerWnd,NULL,TRUE);
			}
		} else
#endif
		{
			hr = m_pBasicVideo->SetSourcePosition(SrcX,SrcY,SrcWidth,SrcHeight);
			hr = m_pBasicVideo->SetDestinationPosition((wX-vx)/2,(wY-vy)/2,vx,vy);
			hr = m_pVideoWindow->HideCursor(m_bFullscreen?OATRUE:OAFALSE);
			hr = m_pVideoWindow->SetWindowPosition(0,0,wX,wY);
		}
		return true;
	}
	return false;
}

const bool CMediaViewer::SetViewSize(const int x,const int y)
{
	// EBhETCYݒ肷
	if(x>0 && y>0){
		m_wVideoWindowX = x;
		m_wVideoWindowY = y;
		return ResizeVideoWindow();
		}
	return false;
}

const bool CMediaViewer::SwitchFullscreen()
{
	// EBhE[hƃtXN[[h؂ւ	
	if(m_pVideoWindow){
		m_bFullscreen = !m_bFullscreen;
		m_pVideoWindow->put_Visible(OAFALSE);
		if(m_bFullscreen){
			m_pVideoWindow->put_Owner(NULL);			
			} else {
			m_pVideoWindow->put_Owner((OAHWND)m_hOwnerWnd);
			}
		m_pVideoWindow->put_Visible(OATRUE);
		ResizeVideoWindow();
		}		
	return true;
	/*
	long lMode;
	if(m_pVideoWindow){
		HRESULT hr = m_pVideoWindow->get_FullScreenMode(&lMode);
		if(SUCCEEDED(hr)){
			RECT Rect;
			if(lMode==OATRUE){
				// to Window
				hr = m_pVideoWindow->put_FullScreenMode(OAFALSE);
				if(SUCCEEDED(hr)){
					return true;
					}
			} else {
				// to Fullscreen
				hr = m_pVideoWindow->put_FullScreenMode(OATRUE);
				if(SUCCEEDED(hr)){
					return true;
					}
				}		
			}
		}
	return false;
	*/
}

const bool CMediaViewer::SetVolume(const float fVolume)
{
	// I[fBI{[dBŐݒ肷( -100.0() < fVolume < 0(ő) )
	if(m_pBasicAudio){
		long lVolume = (long)(fVolume * 100);
		if(lVolume>=-10000&&lVolume<=0){
			TRACE(_T("Volume Control = %d\n"),lVolume);
			HRESULT hr = m_pBasicAudio->put_Volume(lVolume);
			if(SUCCEEDED(hr)){
				return true;
				}
			}
		}
	return false;
}

const bool CMediaViewer::GetVideoSize(WORD *pwWidth,WORD *pwHeight) const
{
	// rfĨTCY擾
	if(m_pMpeg2SeqFilter){
		return m_pMpeg2SeqFilter->GetVideoSize(pwWidth,pwHeight);
		}
	return false;
}

const bool CMediaViewer::GetVideoAspectRatio(BYTE *pbyAspectRatioX,BYTE *pbyAspectRatioY) const
{
	// rfĨAXyNg擾
	if(m_pMpeg2SeqFilter){
		return m_pMpeg2SeqFilter->GetAspectRatio(pbyAspectRatioX,pbyAspectRatioY);
		}
	return false;
}

const BYTE CMediaViewer::GetAudioChannelNum()
{
	// I[fBI̓̓`l擾
	if(m_pAacDecFilter){
		return m_pAacDecFilter->GetCurrentChannelNum();
		}
	return 0;
}

const bool CMediaViewer::SetStereoMode(const int iMode)
{
	// XeIo̓`l̐ݒ
	if(m_pPcmSelFilter){
		m_pPcmSelFilter->SetStereoMode(iMode);
		return true;
		}
	return false;
}

const bool CMediaViewer::GetVideoDecorderName(LPWSTR lpName,int iBufLen)
{
	// IĂrfIfR[_[̎擾
	if(m_pFilterGraph){
		if(m_strMpeg2DecorderName.GetLength()+1<iBufLen){
			lstrcpyW(lpName,m_strMpeg2DecorderName.GetBuffer());
			return true;
			}
		}
	return false;
}

const bool CMediaViewer::DisplayVideoDecorderProperty(HWND hWndParent)
{
	// rfIfR[_[̃vpeBJ
	bool bRet = false;
	FILTER_INFO FilterInfo;
	ISpecifyPropertyPages *pProp = NULL;
	IUnknown *pFilterUnk=NULL;;
	if(m_pMpeg2DecFilter){		
		HRESULT hr = m_pMpeg2DecFilter->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pProp);
		if(SUCCEEDED(hr)){			
			CAUUID caGUID;
			pProp->GetPages(&caGUID);
			SAFE_RELEASE(pProp);
			hr = m_pMpeg2DecFilter->QueryFilterInfo(&FilterInfo);
			if(SUCCEEDED(hr)){				
				hr = m_pMpeg2DecFilter->QueryInterface(IID_IUnknown, (void **)&pFilterUnk);
				if(SUCCEEDED(hr)){
					OleCreatePropertyFrame(
						hWndParent,             // eEBhEB
						0, 0,                   // \ς݁B
						FilterInfo.achName,     // _CAO {bNX̃LvVB
						1,                      // IuWFNg (tB^̂)B
						&pFilterUnk,            // IuWFNg |C^̔zB
						caGUID.cElems,          // vpeB y[WB
						caGUID.pElems,          // vpeB y[W CLSID ̔zB
						0,                      // P[ʎqB
						0, NULL                 // \ς݁B
					);
					SAFE_RELEASE(pFilterUnk);
					bRet = true;
					}
				SAFE_RELEASE(FilterInfo.pGraph);
				}
			}
		}
	return bRet;
}

const bool CMediaViewer::DisplayVideoRanderProperty(HWND hWndParent)
{
	// IȂ̂ŁA
	return false;
}

HRESULT CMediaViewer::AddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister) const
{
	// fobOp
	IMoniker * pMoniker;
	IRunningObjectTable *pROT;
	if(FAILED(::GetRunningObjectTable(0, &pROT)))return E_FAIL;
	
	WCHAR wsz[256];
	wsprintfW(wsz, L"FilterGraph %08p pid %08x", (DWORD_PTR)pUnkGraph, ::GetCurrentProcessId());

	HRESULT hr = ::CreateItemMoniker(L"!", wsz, &pMoniker);

	if(SUCCEEDED(hr)){
		hr = pROT->Register(0, pUnkGraph, pMoniker, pdwRegister);
		pMoniker->Release();
		}
	
	pROT->Release();
	
	return hr;
}

void CMediaViewer::RemoveFromRot(const DWORD dwRegister) const
{
	// fobOp
	IRunningObjectTable *pROT;

	if(SUCCEEDED(::GetRunningObjectTable(0, &pROT))){
		pROT->Revoke(dwRegister);
		pROT->Release();
		}
}




const bool CMediaViewer::ForceAspectRatio(int AspectX,int AspectY)
{
	m_ForceAspectX=AspectX;
	m_ForceAspectY=AspectY;
	return true;
}


const bool CMediaViewer::GetEffectiveAspectRatio(BYTE *pAspectX,BYTE *pAspectY)
{
	if (m_ForceAspectX!=0 && m_ForceAspectY!=0) {
		if (pAspectX)
			*pAspectX=m_ForceAspectX;
		if (pAspectY)
			*pAspectY=m_ForceAspectY;
		return true;
	}
	return GetVideoAspectRatio(pAspectX,pAspectY);
}


const bool CMediaViewer::SetPanAndScan(BYTE bFlags)
{
	m_PanAndScan=bFlags;
	return true;
}


const bool CMediaViewer::GetOriginalVideoSize(WORD *pWidth,WORD *pHeight) const
{
	if (m_pMpeg2SeqFilter==NULL)
		return false;
	return m_pMpeg2SeqFilter->GetOriginalVideoSize(pWidth,pHeight);
}


const bool CMediaViewer::GetDestRect(RECT *pRect)
{
#ifdef VMR9_SUPPORTED
	if (m_pVMR9) {
		IVMRWindowlessControl9 *pWindowlessControl;
		HRESULT hr;

		if (FAILED(m_pVMR9->QueryInterface(IID_IVMRWindowlessControl9,
							reinterpret_cast<LPVOID*>(&pWindowlessControl))))
			return false;
		hr=pWindowlessControl->GetVideoPosition(NULL,pRect);
		pWindowlessControl->Release();
		return SUCCEEDED(hr);
	}
#endif
	{
		long Width,Height;

		if (m_pBasicVideo==NULL
				|| FAILED(m_pBasicVideo->GetDestinationPosition(
									&pRect->left,&pRect->top,&Width,&Height)))
			return false;
		pRect->right=pRect->left+Width;
		pRect->bottom=pRect->top+Height;
	}
	return true;
}


const bool CMediaViewer::GetDestSize(WORD *pWidth,WORD *pHeight)
{
	RECT rc;

	if (!GetDestRect(&rc))
		return false;
	if (pWidth)
		*pWidth=(WORD)(rc.right-rc.left);
	if (pHeight)
		*pHeight=(WORD)(rc.bottom-rc.top);
	return true;
}


const bool CMediaViewer::GetCroppedVideoSize(WORD *pWidth,WORD *pHeight)
{
	WORD Width,Height;

	if (!GetVideoSize(&Width,&Height))
		return false;
	if (m_PanAndScan&PANANDSCAN_HORZ)
		Width=Width*12/16;
	if (m_PanAndScan&PANANDSCAN_VERT)
		Height=Height*9/12;
	if (pWidth)
		*pWidth=Width;
	if (pHeight)
		*pHeight=Height;
	return true;
}


const bool CMediaViewer::GetSourceRect(RECT *pRect)
{
/*
#ifdef VMR9_SUPPORTED
	if (m_pVMR9) {
		IVMRWindowlessControl9 *pWindowlessControl;
		HRESULT hr;

		if (FAILED(m_pVMR9->QueryInterface(IID_IVMRWindowlessControl9,
							reinterpret_cast<LPVOID*>(&pWindowlessControl))))
			return false;
		hr=pWindowlessControl->GetVideoPosition(pRect,NULL);
		pWindowlessControl->Release();
		return SUCCEEDED(hr);
	}
#endif
	{
		long Width,Height;

		if (m_pBasicVideo==NULL
				|| FAILED(m_pBasicVideo->GetSourcePosition(
									&pRect->left,&pRect->top,&Width,&Height)))
			return false;
		pRect->right=pRect->left+Width;
		pRect->bottom=pRect->top+Height;
	}
	return true;
*/
	if (!CalcSourcePosition(&pRect->left,&pRect->top,
												&pRect->right,&pRect->bottom))
		return false;
	pRect->right+=pRect->left;
	pRect->bottom+=pRect->top;
	return true;
}


const void CMediaViewer::HideCursor(bool bHide)
{
	if (m_pVideoWindow)
		m_pVideoWindow->HideCursor(bHide?OATRUE:OAFALSE);
}


const bool CMediaViewer::CalcSourcePosition(long *pLeft,long *pTop,
											long *pWidth,long *pHeight) const
{
	long SrcX,SrcY,SrcWidth,SrcHeight;

	SrcX=m_VideoInfo.wPosX;
	SrcY=m_VideoInfo.wPosY;
	SrcWidth=m_VideoInfo.wWidth;
	SrcHeight=m_VideoInfo.wHeight;
	if (m_PanAndScan&PANANDSCAN_HORZ) {
		int NewWidth=SrcWidth*12/16;
		SrcX=(SrcWidth-NewWidth)/2;
		SrcWidth=NewWidth;
	}
	if (m_PanAndScan&PANANDSCAN_VERT) {
		int NewHeight=SrcHeight*9/12;
		SrcY=(SrcHeight-NewHeight)/2;
		SrcHeight=NewHeight;
	}
	if (pLeft)
		*pLeft=SrcX;
	if (pTop)
		*pTop=SrcY;
	if (pWidth)
		*pWidth=SrcWidth;
	if (pHeight)
		*pHeight=SrcHeight;
	return true;
}


const bool CMediaViewer::GetCurrentImage(BYTE **ppDib)
{
	bool fOK=false;

#ifdef VMR9_SUPPORTED
	if (m_pVMR9) {
		IVMRWindowlessControl9 *pWindowlessControl;

		if (SUCCEEDED(m_pVMR9->QueryInterface(IID_IVMRWindowlessControl9,
							reinterpret_cast<LPVOID*>(&pWindowlessControl)))) {
			fOK=SUCCEEDED(pWindowlessControl->GetCurrentImage(ppDib));
			pWindowlessControl->Release();
		}
	} else
#endif
	if (m_pBasicVideo) {
		long Size;

		if (SUCCEEDED(m_pBasicVideo->GetCurrentImage(&Size,NULL)) && Size>0) {
			*ppDib=(BYTE*)CoTaskMemAlloc(Size);
			if (*ppDib!=NULL) {
				if (SUCCEEDED(m_pBasicVideo->GetCurrentImage(&Size,
											reinterpret_cast<long*>(*ppDib)))) {
					fOK=true;
				} else {
					CoTaskMemFree(*ppDib);
					*ppDib=NULL;
				}
			}
		}
	}
	return fOK;
}


void *CMediaViewer::DoCapture(DWORD WaitTime)
{
#if 0
	void *pDib;

	if (m_pGrabber==NULL)
		return NULL;
	if (!m_pGrabber->SetCapture(true))
		return NULL;
	if (!m_pGrabber->WaitCapture(WaitTime)) {
		m_pGrabber->SetCapture(false);
		return NULL;
	}
	pDib=m_pGrabber->GetCaptureBitmap();
	m_pGrabber->SetCapture(false);
	return pDib;
#else
	return NULL;
#endif
}


#ifdef VMR9_SUPPORTED


const bool CMediaViewer::SetVMR9(bool bVMR9)
{
	m_bVMR9=bVMR9;
	return true;
}


const bool CMediaViewer::RepaintVideo(HWND hwnd,HDC hdc)
{
	if (m_pVMR9) {
		IVMRWindowlessControl9 *pWindowlessControl;

		if (SUCCEEDED(m_pVMR9->QueryInterface(IID_IVMRWindowlessControl9,
							reinterpret_cast<LPVOID*>(&pWindowlessControl)))) {
			pWindowlessControl->RepaintVideo(hwnd,hdc);
			pWindowlessControl->Release();
		}
	}
	return true;
}


const bool CMediaViewer::DisplayModeChanged()
{
	if (m_pVMR9) {
		IVMRWindowlessControl9 *pWindowlessControl;

		if (SUCCEEDED(m_pVMR9->QueryInterface(IID_IVMRWindowlessControl9,
							reinterpret_cast<LPVOID*>(&pWindowlessControl)))) {
			pWindowlessControl->DisplayModeChanged();
			pWindowlessControl->Release();
		}
	}
	return true;
}


const bool CMediaViewer::DrawText(LPCTSTR pszText,HFONT hfont,COLORREF crColor,
												int Opacity,RECT *pDestRect)
{
	IVMRWindowlessControl9 *pWindowlessControl;
	WORD VideoWidth,VideoHeight;
	LONG Width,Height;
	RECT rc;

	if (m_pVMR9==NULL)
		return false;
	if (m_pImageMixer==NULL)
		m_pImageMixer=new CImageMixer(m_pVMR9);
	if (FAILED(m_pVMR9->QueryInterface(IID_IVMRWindowlessControl9,
							reinterpret_cast<LPVOID*>(&pWindowlessControl))))
		return false;
	pWindowlessControl->GetNativeVideoSize(&Width,&Height,NULL,NULL);
	pWindowlessControl->Release();
	GetVideoSize(&VideoWidth,&VideoHeight);
	rc.left=pDestRect->left*Width/VideoWidth;
	rc.top=pDestRect->top*Height/VideoHeight;
	rc.right=pDestRect->right*Width/VideoWidth;
	rc.bottom=pDestRect->bottom*Height/VideoHeight;
	return m_pImageMixer->SetText(pszText,hfont,crColor,Opacity,&rc);
}


const bool CMediaViewer::ClearOSD()
{
	if (m_pVMR9==NULL)
		return false;
	if (m_pImageMixer!=NULL)
		m_pImageMixer->Clear();
	return true;
}


#endif	// VMR9_SUPPORTED
